=encoding utf8

=head1 NAME

Mail::Box::MH::Index - keep index files for messages.

=head1 INHERITANCE

 Mail::Box::MH::Index
   is a Mail::Reporter

=head1 SYNOPSIS

  my $index = Mail::Box::MH::Index->new;
  $index->read(...)
  $index->write(...)

=head1 DESCRIPTION

Message folders which store their data in one single file per message are
very inefficient for producing subject overviews and for computing message
threads.  The C<Mail::Box::MH::Index> object is able to store and read a the
headers of a set of C<Mail::Box::MH::Message> messages which are
part of a single C<Mail::Box::MH> folder in one file.

When the C<Mail::Box::MH::Index> functionality is enabled by specifying
L<Mail::Box::MH::new(keep_index)|Mail::Box::MH/"METHODS"> when opening a folder, the index file
is automatically read.  When the folder is closed, a new index file is
created.

Special care is taken to avoid problems which occur when the user changes
or removes message files without updating the index. If the index is not
trustworthy it will not be used (costing some performance for the reader
of the folder).

Extends L<"DESCRIPTION" in Mail::Reporter|Mail::Reporter/"DESCRIPTION">.

=head1 METHODS

Extends L<"METHODS" in Mail::Reporter|Mail::Reporter/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Reporter|Mail::Reporter/"Constructors">.

=over 4

=item $class-E<gt>B<new>(%options)

Inherited, see L<Mail::Reporter/"Constructors">

 -Option   --Default
  filename   <required>
  head_type  Mail::Message::Head::Subset
  head_wrap  72

=over 2

=item filename => $file

The C<$file> which is used to store the headers of all the e-mails for
one folder. This must be an absolute pathname.

=item head_type => $class

The type of headers which will be used to store header information when
it is read from the index file.  You can not be sure the index contains
all header line (the mailbox may have been updated without updating
the index) so this will usually be (an sub-class of)
L<Mail::Message::Head::Subset|Mail::Message::Head::Subset>.

=item head_wrap => $nrchars

The preferred maximum number of characters in each header line.

=back

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Reporter|Mail::Reporter/"Attributes">.

=over 4

=item $obj-E<gt>B<filename>()

Returns the name of the index file.

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Reporter|Mail::Reporter/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Reporter|Mail::Reporter/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head2 The Index

=over 4

=item $obj-E<gt>B<append>(@messages)

Append C<@messages> to the index file.

=item $obj-E<gt>B<get>($msgfile)

Look if there is header info for the specified C<$msgfile>.  The filename
represents one message in folder type which are organized as directory.
This method will return an object of the L<new(head_type)|Mail::Box::MH::Index/"Constructors"> as specified
during creation of the index object, or C<undef> if the information
is not known or not trustworthy -i.e. the file size changed.

=item $obj-E<gt>B<read>()

Read the index file.  The header objects can after this be requested
with the L<get()|Mail::Box::MH::Index/"The Index"> method.

=item $obj-E<gt>B<write>(@messages)

Write an index file containing the headers specified C<@messages>
(L<Mail::Message|Mail::Message> objects).

=back

=head1 DIAGNOSTICS

=over 4

=item Error: MH index requires a filename.

Cast by C<new()>

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=back

=head1 SEE ALSO

This module is part of Mail-Box version 4.02,
built on April 10, 2026. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

